// SerDownloadDlg.cpp : implementation file
//

#pragma pack(1)
extern "C" {
#include "SerDownl.h"
};
#pragma pack()

#include "stdafx.h"
#include "SerDownload.h"
#include "SerDownloadDlg.h"
#include "KSFileDialog.h"
#include "fileheader.h"
#include "PasswordDlg.h"
#include "Cryptor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
void CheckMessages();

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnWebsite();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_WEBSITE, OnWebsite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerDownloadDlg dialog

CSerDownloadDlg::CSerDownloadDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSerDownloadDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSerDownloadDlg)
	m_Status = _T("");
	m_Boards = _T("");
	m_RomFile = _T("");
	m_Answer = FALSE;
	m_Baud = _T("");
	m_Port = _T("");
	m_Modem = FALSE;
	m_ModemInit = _T("");
	m_PhoneNumber = _T("");
	m_RamFile = _T("");
	m_Retries = 5;
	m_ShortPackets = FALSE;
	m_ForceRam = FALSE;
	m_RS485 = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_NoPoll=m_Connected=m_Abort=m_ASockInit=false;
	m_Retries=AfxGetApp()->GetProfileInt("Settings","Retries",5);
	m_ShortPackets=AfxGetApp()->GetProfileInt("Settings","Short Packets",0);
	m_Update=0;
	m_DebugWin=NULL;
	m_UserBlock=0x40000;
	m_CheckUserBlock=true;
	m_TermIsDebug=false;
}

void CSerDownloadDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerDownloadDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Text(pDX, IDC_STATUS, m_Status);
	DDX_Text(pDX, IDC_BOARDS, m_Boards);
	DDX_Text(pDX, IDC_ROM_FILE, m_RomFile);
	DDX_Check(pDX, IDC_ANSWER, m_Answer);
	DDX_CBString(pDX, IDC_BAUD, m_Baud);
	DDX_CBString(pDX, IDC_COMPORT, m_Port);
	DDX_Check(pDX, IDC_MODEM, m_Modem);
	DDX_Text(pDX, IDC_MODEMINIT, m_ModemInit);
	DDX_Text(pDX, IDC_PHONENUMBER, m_PhoneNumber);
	DDX_Text(pDX, IDC_RAM_FILE, m_RamFile);
	DDX_Text(pDX, IDC_RETRIES, m_Retries);
	DDX_Check(pDX, IDC_SHORTPACKETS, m_ShortPackets);
	DDX_Check(pDX, IDC_FORCERAM, m_ForceRam);
	DDX_Check(pDX, IDC_RS485, m_RS485);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSerDownloadDlg, CDialog)
	//{{AFX_MSG_MAP(CSerDownloadDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SEARCH, OnSearch)
	ON_BN_CLICKED(IDC_DOWNLOAD, OnDownload)
	ON_BN_CLICKED(IDC_ABORT, OnAbort)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_BN_CLICKED(IDC_SETROMFILE, OnSetROMFile)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_SETRAMFILE, OnSetRamFile)
	ON_BN_CLICKED(IDC_MODEM, OnModem)
	ON_BN_CLICKED(IDC_TERMINAL, OnTerminal)
	ON_BN_CLICKED(IDC_SHORTPACKETS, OnShortPackets)
	ON_EN_CHANGE(IDC_RETRIES, OnChangeRetries)
	ON_BN_CLICKED(IDC_RS485, OnRs485)
	ON_BN_CLICKED(IDC_UBCHECK, OnUBCheck)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerDownloadDlg message handlers

BOOL CSerDownloadDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_RomFile=AfxGetApp()->GetProfileString("Settings","ROM File","program.bin");
	m_RamFile=AfxGetApp()->GetProfileString("Settings","RAM File","SerDownl.bin");
	m_Port=AfxGetApp()->GetProfileString("Settings","Com Port","COM1:");
	m_Baud=AfxGetApp()->GetProfileString("Settings","Com Baud","9600");
	m_Modem=AfxGetApp()->GetProfileInt("Settings","Modem",0);
	m_CheckUserBlock=AfxGetApp()->GetProfileInt("Settings","Check User Block",1)!=0;
	m_Answer=AfxGetApp()->GetProfileInt("Settings","Answer",0);
	m_ModemInit=AfxGetApp()->GetProfileString("Settings","Modem Init","ATZ\\nATM1\\nATV1\\n");
	m_PhoneNumber=AfxGetApp()->GetProfileString("Settings","Phone Number","");
	m_RS485=0;
	SetTimer(1,1000,NULL);
	UpdateData(FALSE);
	OnModem();
	CButton* bt=(CButton*)GetDlgItem(IDC_UBCHECK);
	bt->SetCheck(m_CheckUserBlock?1:0);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSerDownloadDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSerDownloadDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSerDownloadDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSerDownloadDlg::ASockInit()
{
	if (m_ASockInit)
		return;	// already done
	m_ASock.Create(0,SOCK_DGRAM);
	m_ASockInit=true;
}

void CSerDownloadDlg::OnTimer(UINT nIDEvent) 
{
	static searchtimer=20;
	if (nIDEvent==1)
	{
		KillTimer(1);
		int boards=m_IPList.GetSize();	// any boards?
		if (!m_NoPoll&&m_Connected)
			CheckRx();
		else
			if (m_Modem)
				ConnectProcess();
		if (m_DebugWin==NULL)
		{
			if (boards==0&&m_IPList.GetSize()) // found a new one
			{
				if (m_Modem&&m_Answer)
				{
					OnDownload();
					m_IPList.RemoveAll();
					OnAbort();	// drop connection;
					m_Abort=false;
					OnConnect(); //do next
				}
			}
			if (!m_NoPoll&&m_Connected&&m_IPList.GetSize()==0)
			{
				if (--searchtimer<=0)
				{
					if (++m_SearchTries<=5)
					{
						Ping();
					}
					searchtimer=40;
				}
			}
		}
		SetTimer(1,50,NULL);
	}
	else
	CDialog::OnTimer(nIDEvent);
}

void CSerDownloadDlg::OnSearch() 
{
	CloseTerminal();
	m_SearchTries=0;
	Ping();
}

void CheckMessages()
{
	MSG msg;
	while ( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) 
		if ( !AfxGetApp()->PumpMessage( ) ) 
		{ 
			::PostQuitMessage(0); 
			break; 
		}
	AfxGetApp()->OnIdle(0);	// idle processing
}

void CSerDownloadDlg::OnDownload() 
{
	static bool busy=false;
	if (busy)
		return;
	busy=true;
	CloseTerminal();
	int boardnum=0;
	UpdateData(TRUE);
	m_Update=1;
	CString lastfile;
	if (m_IPList.GetSize()==0)
	{
		AfxMessageBox("No boxes in list, run search first.");
		busy=false;
		return;
	}
	m_Abort=false;
	if (m_IPList[boardnum].NeedsRamCode||m_IPList[boardnum].HasCodeInXmem)
	{
		if (!m_IPList[boardnum].HasCodeInXmem||m_ForceRam)
		{
			if (!DownloadCode(boardnum,m_RamFile,UDPDNLD_DOWNLOAD_RAM))
			{
				busy=false;
				return;
			}
			AfxGetApp()->WriteProfileString("Settings","Ram File",m_RamFile);
		}
		SER_COMM_HEADER up;
		up.cmd=UDPDNLD_RUN;
		up.address=0;
		up.length=0;
		up.status=0;
		if (!SendPacket(&up))
			AddStatus("Failed to transmit RUN command!\r\n");
		else
			AddStatus("Sent RAM Loader Run command to target!\r\n");

		int retry=15;
		bool found=false;
		AddStatus("Searching for board (looking for RAM loader)\r\n");
		bool firstping=true;
		m_NoPoll=true;
		while (!m_Abort&&!found&&--retry)
		{
			int timeout=25;
			Sleep(20);	// arbitrary
			Ping(firstping);	// redo search
			firstping=false;
			AddStatus(".");
			while (!m_Abort&&!found&&--timeout)
			{
				for (int i=0;i<m_IPList.GetSize();i++)
				{
					if (m_IPList[i].NeedsRamCode==false)
					{
						found=true;
						boardnum=i;
						break;
					}
				}
				CheckMessages();
				if (!found)
					CheckRx();
			}
		}
		if (m_Abort||!found)
		{
			m_NoPoll=m_Abort=false;
			AddStatus("Error - Ram Loader not found.\r\n");
			busy=false;
			return;
		}
		else
			AddStatus("\r\n");
	}
	m_NoPoll=false;
	if (!DownloadCode(boardnum,m_RomFile,UDPDNLD_DOWNLOAD_FLASH))
	{
		busy=false;
		return;
	}
	m_NoPoll=true;
	AfxGetApp()->WriteProfileString("Settings","ROM File",m_RomFile);
	int retry=m_Retries;
	m_RebootAck=false;
	while (!m_RebootAck&&--retry>0)
	{
		SER_COMM_HEADER up;
		up.address=up.length=0;
		up.cmd=UDPDNLD_REBOOT;
		up.status=0;
		if (!SendPacket(&up))
			AddStatus("Failed to transmit Reboot command!\r\n");
		else
			AddStatus("Sent Reboot command to target\r\n");
		{
			CheckMessages();
			for (int i=1;!m_RebootAck&&(i<10);i++)
				if (!CheckRx())
					Sleep(100);
		}
	}
	if (!m_RebootAck)
			AddStatus("No Reboot reply from target!\r\n");

	m_NoPoll=false;
	busy=false;
	Ping(false);
}

bool CSerDownloadDlg::DownloadCode(int boardnum, CString filename, int type)
{
	bool encrypted=false;
	int skip1st=0x100000;	// 1 meg space
	char *s;
	int block_size=m_IPList[boardnum].MTU;	// safe value
	if (block_size>1024)
		block_size=1024;	// should be optimum size
	if (m_ShortPackets&&(block_size>256))
		block_size=256;

	block_size&=0xfffe;	// must be even
	EHEADER hdr;
	CCryptor crypt;
	CFile fp;
	if (!fp.Open(filename,CFile::modeRead))
	{
		CString err;
		err.Format("Could not open file %s!",filename);
		AfxMessageBox(err);
		return false;
	}
	fp.Read(&hdr,sizeof(hdr));
	if (strcmp(hdr.ID,ENCRYPTED_ID)==0)	// encrypted??
	{	
		int i;
		if ((hdr.Password[0]|hdr.Password[0]|hdr.Password[0])==0)
			crypt.Set_Key(0,0,0);
		else
		{
			CPasswordDlg dlg;
			if (dlg.DoModal()!=IDOK)
				return false;
			crypt.Set_Key(0,0,0);
			s=(char *)LPCSTR(dlg.m_Password);
			for (i=0;i<dlg.m_Password.GetLength();i++)
				crypt.Transform_Char(s++);
			if ((crypt.m_LFSR_A!=hdr.Password[0])||
				(crypt.m_LFSR_B!=hdr.Password[1])||
				(crypt.m_LFSR_C!=hdr.Password[2]))
			{
				AfxMessageBox("Incorrect password");
				fp.Close();
				return false;
			}
		}
		s=(char *)&hdr.Key;
		// decrypt the key
		for (i=0;i<sizeof(hdr.Key);i++)
			crypt.Transform_Char(s++);
		crypt.Set_Key(hdr.Key[0],hdr.Key[1],hdr.Key[2]);
		encrypted=true;
		AddStatus("File is encrypted.\r\n");
	}
	else
		fp.Seek(0,CFile::begin);
	int address=0;
	int size,fsize=fp.GetLength();
	if (encrypted)
		fsize-=sizeof(hdr);	// skip header size
	size=fsize;
	m_Progress.SetRange(0,100);
	m_Progress.SetPos(0);
	m_Progress.ShowWindow(SW_SHOW);
	if (type==UDPDNLD_DOWNLOAD_RAM)
	{
		if (fsize>32768)
		{
			AddStatus("RAM Loader >32767, invalid size.\r\nDownload Aborted.\r\n");
			fp.Close();
			return false;
		}
		SER_COMM_HEADER up;
		up.cmd=UDPDNLD_XMEM_SIZE;
		up.address=size;
		up.status=0;
		up.length=0;
		if (!SendPacket(&up))
			AddStatus("Failed to transmit RAM size command!\r\n");
		else
			AddStatus("Sent RAM Loader Size to target!\r\n");
		m_XSizeAck=false;
		KillTimer(1);	// we will poll
		int poll=250;
		while (!m_Abort&&--poll)
		{
			if (!CheckRx())
				Sleep(5);
			if (m_XSizeAck)
				break;
			CheckMessages();
		}
		SetTimer(1,1000,NULL); // restart timer
		if (poll==0)
		{
			AddStatus("Failed to get XMem size ack!\r\n");
			m_Abort=true;
		}
	}
	if (m_Abort)
	{
			AddStatus("Download Aborted.\r\n");
			fp.Close();
			return false;
	}
	int retry=m_Retries;
	char *buff=new char[fsize];
	size=fp.Read(buff,fsize);
	if (size!=fsize)
	{
		AddStatus("Failed to read full file.\r\n");
		fsize=size;
	}
	if (encrypted)
	{
		s=(char *)buff;
		// decrypt the key
		for (int i=0;i<fsize;i++)
			crypt.Transform_Char(s++);
	}
	if ((type!=UDPDNLD_DOWNLOAD_RAM)&&(fsize>0x40000))
	{
		unsigned long * zptr=(unsigned long *)(buff+262140);
		while (*zptr==0)
			zptr--;
		zptr++;
		skip1st=((char *)zptr)-buff;	// start of blank area
		skip1st=skip1st+m_IPList[boardnum].BlockSize-1;
		skip1st=skip1st&~(m_IPList[boardnum].BlockSize-1);
		if (m_CheckUserBlock)
		{
			m_UserBlock=0x40000;
			SER_COMM_HEADER up;
			up.cmd=UDPDNLD_GET_USERBLOCK;
			up.address=0;
			up.length=0;
			up.status=0;
			m_Ack=false;
			retry=3;
			while (retry--&&!m_Ack)
			{
				if (!SendPacket(&up))
					AddStatus("Failed to transmit query Userblock Addr!\r\n");
				else
					AddStatus("Sent RAM Loader Query Userblock Addr.\r\n");
				int timeout=50;
				while (!m_Abort&&!m_Ack&&--timeout)
				{
						CheckMessages();
						if (!CheckRx())
							Sleep(20);
				}
			}
			if (!m_Ack)
				AddStatus("No reply from user block request.  Will try to determine from .bin file.\r\n");
			else
				skip1st=m_UserBlock;
		}
		CString tmp;
		tmp.Format("Start of user block: %x, blocksize=%d\r\n",skip1st,m_IPList[boardnum].BlockSize);
		AddStatus(tmp);
	}
	char * cbuff=new char [SER_COMM_HEADER_SIZE +block_size+8];
	while (!m_Abort&&size>0)
	{
		int len;
		SER_COMM_HEADER *up=(SER_COMM_HEADER*)cbuff;
		up->address=address;
		up->cmd=type;
		len=size;
		if (len>block_size)
			len=block_size;
		if ((address<skip1st)&&(address+len>skip1st))
			len=skip1st-address;
		else
		if ((address>=skip1st)&&(address<0x40000))
		{
			AddStatus("Skipping over User block and ID block\r\n.");
			len=0x40000-address;
			address=0x40000;
			size-=len;
			continue;
		}
		m_Ack=false;
		while (!m_Ack&&retry)
		{
			m_Ack=false;
			up->length=len;
			memcpy(up->data,buff+address,len);
			up->status=0;
			if (len)
			{
				if (!SendPacket((SER_COMM_HEADER *)cbuff))
				{
					AddStatus("Failed to transmit block!\r\n");
				}
			}
			KillTimer(1);
			int poll=200;
			while (!m_Abort&&--poll)
			{
				
				CheckRx();
				if (m_Ack)
					break;
				CheckMessages();
			}
			SetTimer(1,1000,NULL); // restart timer
			if (m_Abort)
				break;
			if (poll>0)
			{
				size-=len;
				address+=len;
				CString prog;
				prog.Format("Download progress: %d ",100*address/fsize);
				GetDlgItem(IDC_DPROG)->SetWindowText(prog);
				m_Progress.SetPos(100*address/fsize);
			}
			else
			if(--retry==0)
			{
				AddStatus("Retries failed, abort download!\r\n");
				delete buff;
				delete cbuff;
				GetDlgItem(IDC_DPROG)->SetWindowText("");
				m_Progress.ShowWindow(SW_HIDE);
				fp.Close();
				return false;
			}
			else
			{
				AddStatus("No Response, retry block!\r\n");
			}
		}
	}
	delete [] cbuff;
	delete [] buff;
	fp.Close();
	if (m_Abort)
	{
			AddStatus("Download Aborted.\r\n");
			GetDlgItem(IDC_DPROG)->SetWindowText("");
			m_Progress.ShowWindow(SW_HIDE);
			return false;
	}
	AddStatus("Download Complete :)\r\n");
	m_Progress.ShowWindow(SW_HIDE);
	return true;
}


void CSerDownloadDlg::OnAbort() 
{
	m_Abort=true;
	if (m_Connected)
	{
		if (m_Modem)
		{
			m_IPList.RemoveAll();
			m_Boards.Empty();
			Hangup();
		m_Connected=false;
		}
	}
}

void CSerDownloadDlg::OnAbout() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CSerDownloadDlg::OnSetROMFile() 
{
	UpdateData(TRUE);	// update screen
	CKSFileDialog dlg(TRUE,NULL,m_RomFile,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Rabbit Image files (*.bin)|*.bin|All files (*.*)|*.*|");
	dlg.SetMyParent(this);
	if (dlg.DoModal()==IDOK)
	{
		m_RomFile=dlg.GetPathName();
		UpdateData(FALSE);	// update screen
		m_Update=1;
		AfxGetApp()->WriteProfileString("Settings","ROM File",m_RomFile);
	}
}

void CSerDownloadDlg::AddStatus(LPCSTR s)
{
//	if (m_Status.GetLength())
//		m_Status+="\r\n";
	UpdateData(TRUE);
	CString tmp=s+m_Status;
	m_Status=tmp;
	UpdateData(FALSE);
	m_Update=1;
}

void CSerDownloadDlg::OnClear() 
{
	UpdateData(TRUE);
	m_Status="";
	UpdateData(FALSE);
}

bool CSerDownloadDlg::CheckRx()
{
	SER_COMM_HEADER pkt;
	int i;
	IPList ip;
	CString tmp;
	if (!Comm.IsActive())
		return false;
	if (m_DebugWin!=NULL)
	{
		static char buff[1024];
		if (m_DebugWin->m_Keys.GetLength())
		{
			Comm.SendString(m_DebugWin->m_Keys);
			m_DebugWin->m_Keys.Empty();
		}
		int len;
		bool updatew=false;
		while (len=Comm.GetBlock(buff,sizeof(buff)))
		{	
			updatew=true; // data written
			TerminalWrite(m_DebugWin,buff,len);
		}
		if (updatew)
			m_DebugWin->Invalidate();
	}
	else
	if (GetPacket(&pkt))
	{
		m_ConnectTimer=3000; //5 minutes wait
		switch (pkt.cmd)
		{
		case UDPDNLD_REBOOT:
			AddStatus("Board is rebooting.\r\n");
			m_RebootAck=true;
			if (m_Modem)
			{
				Hangup();	// drop connection;
				OnConnect(); //do next
				m_IPList.RemoveAll();
				m_Boards.Empty();
			}
			break;
		case UDPDNLD_QUERY:
			if (pkt.length==0)
				break;	// this is our msg echoed back

			ip.Description=pkt.data;	// copy response
			ip.MTU=pkt.address&0xffff;
			ip.BlockSize=pkt.address>>16;
			if (ip.BlockSize==0)
				ip.BlockSize=512;	// default block size
			ip.NeedsRamCode=pkt.status==UDPDNLD_STATUS_NEED_CODE;
			ip.HasCodeInXmem=pkt.status==UDPDNLD_STATUS_RAM_CODE_IN_XMEM;
			{
				bool exists=false;
				if (m_IPList.GetSize())
				{
					m_IPList.SetAt(0,ip);	// update existing
					exists=true;
				}
				if (!exists)
					m_IPList.Add(ip);
			}
			m_Boards.Empty();
			for (i=0;i<m_IPList.GetSize();i++)
			{
				CString mode;
				if (ip.HasCodeInXmem)
					mode="Has bootloader in XMEM FLASH.";
				else
					if (m_IPList[i].NeedsRamCode)
						mode="Needs Bootloader.";
					else
						mode="Running Bootloader.";
				tmp.Format("Status: MTU=%d, ID: \'%s\' - %s\r\n",m_IPList[i].MTU,m_IPList[i].Description,mode);
				m_Boards+=tmp;
			}
			UpdateData(FALSE);	// update screen
			m_Update=1;
			break;
		case UDPDNLD_DOWNLOAD_RAM:
		case UDPDNLD_DOWNLOAD_FLASH:
			if (pkt.status==UDPDNLD_STATUS_ACK)
				m_Ack=true;
			else
			{
				if (pkt.cmd==UDPDNLD_DOWNLOAD_RAM)
					AddStatus("Error downloading to RAM.\r\n");
				else
					AddStatus("Error writing to FLASH.\r\n");
			}
			break;
		case UDPDNLD_XMEM_SIZE:
			if (pkt.status==UDPDNLD_STATUS_ACK)
				m_XSizeAck=true;
			else
			{
				AddStatus("Error: Board rejected XMEM alloc request.\r\n");
			}
			break;
		case UDPDNLD_DEBUG:
			CreateDebugOut();
			TerminalWrite(m_DebugOut,(char *)&pkt.data,pkt.length);
			break;
		case UDPDNLD_GET_USERBLOCK:
			m_Ack=true;
			tmp.Format("User block reported as: %x\r\n",pkt.address);
			AddStatus(tmp);
			if (pkt.address<0x40000)
				m_UserBlock=pkt.address;
			else
				m_UserBlock=0x40000;

			break;
		}
		return true;
	}
	return false;
}

void CSerDownloadDlg::Ping(bool verbose/*=true*/)
{
	UpdateData(TRUE);
	m_IPList.RemoveAll();
	m_Boards.Empty();
	UpdateData(FALSE);
	m_Update=1;
	SER_COMM_HEADER hdr;
	hdr.address=0;
	hdr.cmd=UDPDNLD_QUERY;
	hdr.status=0;
	hdr.length=0;
	if (!SendPacket(&hdr))
		AddStatus("Failed to transmit Ping query command!\r\n");
	if (verbose)
		AddStatus("Searching for board.\r\n");
}

bool CSerDownloadDlg::GetPacket(SER_COMM_HEADER *pkt)
{
	unsigned char * s;
	s=&pkt->flag;
	if (Comm.GetBlock(s,1)!=1)
		return false;
	if (*s++!=0x7e)
		return false;
	if (Comm.GetBlock(s,SER_COMM_HEADER_SIZE-1)!=SER_COMM_HEADER_SIZE-1)
		return false;
	if (pkt->length>ETH_MTU-8)
		return false;
	if (Comm.GetBlock(&pkt->data,pkt->length+2)!=pkt->length+2)
		return false;
	if (m_RS485)
		Sleep(15);	// slow down so next TX has time to turn buffer around
	return CheckPacket(pkt);
}

unsigned short CSerDownloadDlg::CRC16(unsigned char * pcdataptr,unsigned short uslength,unsigned short uscrc)
{
	unsigned short usdata;
	if (uslength==0) return(0);
	while(uslength--)
	{
		usdata=(*(pcdataptr++))<<8;
		uscrc=((uscrc&0xff)<<8)+(uscrc>>8);
		uscrc=uscrc^usdata;
		usdata=uscrc& 0xff00;
		usdata<<=4;
		uscrc=uscrc^usdata;
		usdata = uscrc & 0xff00;
		usdata >>= 5;
		uscrc = uscrc ^ usdata;
		usdata >>= 7;
	}
	uscrc = ~(((uscrc & 0x00ff) <<8)+ (uscrc >> 8 ));
	return(uscrc);
}
//
// send the ack, don't mess with command, status set to err.
// no data bytes
//

bool CSerDownloadDlg::CheckPacket(SER_COMM_HEADER *pkt)
{
	unsigned short * crcpos;
	crcpos=(unsigned short *)(pkt->data+pkt->length);
	if (CRC16((unsigned char *)pkt,SER_COMM_HEADER_SIZE+pkt->length,0xffff)!=*crcpos)
	{
		TRACE("CRC error - %x/%x\r\n",(unsigned)CRC16((unsigned char *)pkt,SER_COMM_HEADER_SIZE+pkt->length,0xffff),(unsigned)*crcpos);
		return false;
	}
	return true;

}

bool CSerDownloadDlg::SendPacket(SER_COMM_HEADER *pkt)
{
	unsigned short * crc;
	pkt->flag=0x7e;
	crc=(unsigned short *)(pkt->data+pkt->length);
	*crc=CRC16((unsigned char *)pkt,SER_COMM_HEADER_SIZE+pkt->length,0xffff);
	bool ok=(unsigned(Comm.SendBlock(pkt,SER_COMM_HEADER_SIZE+pkt->length+2))==SER_COMM_HEADER_SIZE+pkt->length+2);
	if (m_RS485!=0)
	{
		Comm.WaitTX();
		Comm.PurgeRX();
	}
	return ok;
}

bool CSerDownloadDlg::SendModemCommand(CString &cmd)
{
	int retry=60;
	CString resp;

	while (retry)
	{
		if ((retry%20)==0)
			Comm.SendString(cmd);

		if (Comm.GetLine(resp))
		{
			CString stat("Modem rx: ");
			stat+=resp;
			stat+="\r\n";
			AddStatus(stat);
		}
		if (resp.Find("OK",0)>=0)
			return true;
		retry--;
		Sleep(100);
	}
	return false;
}

void CSerDownloadDlg::OnConnect() 
{
	CString resp;
	UpdateData(TRUE);
	Comm.CloseComm();
	if (!Comm.IsActive())
	{
		CString str;
		int port,baud;
		if (sscanf(m_Port,"COM%d",&port)!=1)
		{
			str.Format("Error in com port name: %s\r\n",m_Port);
			AddStatus(str);
			return;
		}
		if (sscanf(m_Baud,"%d",&baud)!=1)
		{
			str.Format("Error decoding baud rate: %s\r\n",m_Baud);
			AddStatus(str);
			return;
		}
		if (!Comm.OpenComm(port,baud,m_Modem!=0))
		{
			str.Format("Failed to open serial port: %s and %s\r\n",m_Port,m_Baud);
			AddStatus(str);
			return;
		}
		AfxGetApp()->WriteProfileString("Settings","Com Port",m_Port);
		AfxGetApp()->WriteProfileString("Settings","Com Baud",m_Baud);
		str.Format("Serial port: %s opened at %d baud.\r\n",m_Port,baud);
		AddStatus(str);
	}
	m_Abort=false;
	AfxGetApp()->WriteProfileInt("Settings","Modem",m_Modem);
	AfxGetApp()->WriteProfileInt("Settings","Answer",m_Answer);
	AfxGetApp()->WriteProfileString("Settings","Modem Init",m_ModemInit);
	AfxGetApp()->WriteProfileString("Settings","Phone Number",m_PhoneNumber);
	m_SearchTries=0;
	if (m_Modem)
		m_ConnectState =C_INIT;
	else
		m_Connected=true;
	
}

void CSerDownloadDlg::Hangup()
{
	CString resp;
	Comm.SendBlock("+++",3);
	Sleep(1200);
	SendModemCommand(CString("ATH0\r\n"));
	while (Comm.GetLine(resp));	// suck up echo
}

void CSerDownloadDlg::OnSetRamFile() 
{
	UpdateData(TRUE);	// update screen
	CKSFileDialog dlg(TRUE,NULL,m_RamFile,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Rabbit Image files (*.bin)|*.bin|All files (*.*)|*.*|");
	dlg.SetMyParent(this);
	if (dlg.DoModal()==IDOK)
	{
		m_RamFile=dlg.GetPathName();
		UpdateData(FALSE);	// update screen
		m_Update=1;
		AfxGetApp()->WriteProfileString("Settings","RAM File",m_RamFile);
	}
}

void CSerDownloadDlg::EnableModemCtls(bool enable)
{
	GetDlgItem(IDC_MODEMINIT)->EnableWindow(enable?TRUE:FALSE);
	GetDlgItem(IDC_PHONENUMBER)->EnableWindow(enable?TRUE:FALSE);
	GetDlgItem(IDC_ANSWER)->EnableWindow(enable?TRUE:FALSE);
}

void CSerDownloadDlg::OnModem() 
{
	UpdateData(TRUE);
	EnableModemCtls(m_Modem!=0);
}

void CSerDownloadDlg::OnOK() 
{
	AfxGetApp()->WriteProfileInt("Settings","Modem",m_Modem);
	
	CDialog::OnOK();
}

void CSerDownloadDlg::ConnectProcess()
{
	CString lcmd,resp;
	int i;
	switch (m_ConnectState)
	{
	case C_INIT:
		m_SyncTimer=0;
		m_Connected=false;
		Comm.SendBlock("     ",5);	// let modem determine baud rate.
		while (Comm.GetLine(resp));	// suck up echo
		AddStatus("Send Modem Init.\r\n");
		for (i=0;i<m_ModemInit.GetLength();i++)
		{
			if ((m_ModemInit[i]=='\\')&&(m_ModemInit[i+1]=='n'))
			{
				lcmd+="\r\n";
				i++;
				if (!SendModemCommand(lcmd))
				{
					AddStatus(".No response, abort.\r\n");
					return;
				}
				lcmd.Empty();
			}
			else
				lcmd+=m_ModemInit[i];
			CheckMessages();
		}
		AddStatus("Modem OK, Waiting for connection.\r\n");
		if (!m_Answer)
		{
			if (m_PhoneNumber.GetLength()==0)
			{
				AddStatus("Error, no phone # entered.\r\n");
				return;
			}
			Comm.SendBlock("ATDT",4);
			Comm.SendString(m_PhoneNumber);
			Comm.SendBlock("\r\n",2);
			resp="Dialing: ";
			resp+=m_PhoneNumber;
			resp+="\r\n";
			AddStatus(resp);
			m_ConnectState=C_CONNECTW;
			m_SyncTimer=0;
		}
		else
			m_ConnectState=C_RINGW;
		break;
	case C_RINGW:
		if (Comm.GetLine(resp))
		{
			CString stat("Modem rx: ");
			stat+=resp;
			stat+="\r\n";
			AddStatus(stat);
			if (m_Answer&&resp.Find("RING",0)>=0)
			{
				Comm.SendBlock("ATA\r\n",5);
				m_ConnectState=C_CONNECTW;
				m_SyncTimer=0;
			}
		}
		break;
	case C_CONNECTW:
		if (++m_SyncTimer>=1200) // 2 minutes to connect
		{
			AddStatus("Timeout on connect, aborted.\r\n");
			m_ConnectState=C_INIT;
			return;
		}
		if (Comm.GetLine(resp))
		{
			m_SyncTimer=0;	// wait for next reponse
			CString stat("Modem rx: ");
			stat+=resp;
			stat+="\r\n";
			AddStatus(stat);
		
			if (resp.Find("CONNECT",0)>=0)
			{
				resp=resp.Right(resp.GetLength()-resp.Find("CONNECT",0)-7);
				m_Connected=true;
				m_ConnectState=C_CONNECTED;
				m_ConnectTimer=3000; //5 minutes wait
				break;
			}

			if ((resp.Find("NO CARRIER",0)>=0)||
				(resp.Find("NO DIALTONE",0)>=0)||
				(resp.Find("ERROR",0)>=0)||
				(resp.Find("BUSY",0)>=0)||
				(resp.Find("NO ANSWER",0)>=0))
			{
				OnAbort();
				m_Abort=false;
				m_ConnectState=C_INIT;
				return;
			}
		}
		break;
	case C_CONNECTED:
		m_ConnectTimer--;
		if (m_ConnectTimer<=0)
		{
			OnAbort();
			m_ConnectState=C_INIT;
		}
		break;
	}

}

void CSerDownloadDlg::OnTerminal() 
{
	if (m_DebugWin==NULL)
	{
		if (!Comm.IsActive())
		{
			AfxMessageBox("Serial port is not connected.\r\nUse connect first before opening terminal.");
			return;
		}
		m_DebugWin=new CDebugWin;
		m_DebugWin->SetSize(24,80);
		CString Class;
		CRect rect;
		GetWindowRect(&rect);
		rect.OffsetRect(rect.right-rect.left,0);
		Class =AfxRegisterWndClass( CS_HREDRAW|CS_VREDRAW|CS_OWNDC,LoadCursor(NULL,IDC_ARROW));
		if (((CWnd *)m_DebugWin)->CreateEx(WS_EX_CLIENTEDGE   ,Class,"Serial Terminal.",
			WS_POPUP|WS_OVERLAPPEDWINDOW   |WS_MAXIMIZEBOX|WS_MINIMIZEBOX,rect ,this,0)==0)
		{
			delete m_DebugWin;
			m_DebugWin=NULL;
			return ;
		}
		m_DebugWin->Resize();

		m_DebugWin->AddLine("Terminal Window Opened.");
		m_DebugWin->AddLine("");
		m_DebugWin->CRow=m_DebugWin->Rows-1;	// cursor at last line
		m_DebugWin->Show(true);
		m_DebugWin->SetWinPtr(&m_DebugWin);
		m_DebugWin->UpdateCursor();
	}
	else
		CloseTerminal();
}

CSerDownloadDlg::~CSerDownloadDlg()	// standard destructor
{
	if (m_DebugWin!=NULL)
	{
		delete m_DebugWin;
	}
}

void CSerDownloadDlg::CloseTerminal()
{
	if (m_DebugWin!=NULL)
	{
		delete m_DebugWin;
		m_DebugWin=NULL;
	}
}

void CAboutDlg::OnWebsite() 
{
	ShellExecute(NULL,"open","http://shdesigns.org/rabbit",NULL,NULL,SW_SHOW);
}

void CSerDownloadDlg::OnShortPackets() 
{
	UpdateData(TRUE);
	AfxGetApp()->WriteProfileInt("Settings","Short Packets",m_ShortPackets);
}

void CSerDownloadDlg::OnChangeRetries() 
{
	UpdateData(TRUE);
	AfxGetApp()->WriteProfileInt("Settings","Retries",m_Retries);
}

void CSerDownloadDlg::OnRs485() 
{
	UpdateData();	
}

void CSerDownloadDlg::TerminalWrite(CDebugWin * win,char *buff,int len)
{
	for (int i=0;i<len;i++)
		if (buff[i]=='\n')
		{
			win->AddLine("");
			win->CCol=0;
			win->UpdateCursor();
		}
		else
			if (buff[i]=='\r')
				win->CCol=0;
			else
				win->SetChar(m_DebugWin->CRow,m_DebugWin->CCol++,buff[i]);
}

void CSerDownloadDlg::CreateDebugOut()
{
	if (m_DebugOut==NULL)
	{
		if (!Comm.IsActive())
		{
			AfxMessageBox("Serial port is not connected.\r\nUse connect first before opening terminal.");
			return;
		}
		m_DebugOut=new CDebugWin;
		m_DebugOut->SetSize(24,80);
		CString Class;
		CRect rect;
		GetWindowRect(&rect);
		rect.OffsetRect(rect.right-rect.left,0);
		Class =AfxRegisterWndClass( CS_HREDRAW|CS_VREDRAW|CS_OWNDC,LoadCursor(NULL,IDC_ARROW));
		if (((CWnd *)m_DebugOut)->CreateEx(WS_EX_CLIENTEDGE   ,Class,"Serial Terminal.",
			WS_POPUP|WS_OVERLAPPEDWINDOW   |WS_MAXIMIZEBOX|WS_MINIMIZEBOX,rect ,this,0)==0)
		{
			delete m_DebugOut;
			m_DebugOut=NULL;
			return ;
		}
		m_DebugOut->Resize();

		m_DebugOut->AddLine("Terminal Window Opened.");
		m_DebugOut->AddLine("");
		m_DebugOut->CRow=m_DebugOut->Rows-1;	// cursor at last line
		m_DebugOut->Show(true);
		m_DebugOut->SetWinPtr(&m_DebugOut);
		m_DebugOut->UpdateCursor();
	}
}

void CSerDownloadDlg::CloseDebugOut()
{
	if (m_DebugOut!=NULL)
	{
		delete m_DebugOut;
		m_DebugOut=NULL;
	}

}

void CSerDownloadDlg::OnUBCheck() 
{
	CButton* bt=(CButton*)GetDlgItem(IDC_UBCHECK);
	m_CheckUserBlock=bt->GetCheck()!=0;
	AfxGetApp()->WriteProfileInt("Settings","Check User Block",m_CheckUserBlock?1:0);
}
